/*
        if(Dizi.contains("-")==true)
        {
            int yerEksi=Dizi.indexOf("-");
            QString EksiSayi=Dizi.value(yerEksi+1);
            QString YeniEksiSayi="-"+EksiSayi;
            ui->label2->setText("eksiyer: "+QString::number(yerEksi));
            Dizi.replace(yerEksi,"+");
            Dizi.replace(yerEksi+1,YeniEksiSayi);
        }
*/

#include "ehm.h"
#include "ui_ehm.h"
#include <QMessageBox>
#include <math.h>
#include <QFileDialog>
#include <QDir>
#include <QFile>
#include <QTextStream>
#include <QStringList>
#include <QStatusBar>
#include <QTextCodec>

#if defined(__OS2__)
  #define log2(value) log((double)value)/log(2.0)
#endif


QString surum="ehm 0.5";
QString islem;
QString onceki;
QString sonucKS="0";
QString geciciSayi2;
QString geciciSayi1;
QString yedektext;
QString yedektextSon;
QString yedektextBas;
QString diziyeIsaret;
QString silinecek;
QStringList Dizi;
QStringList DiziIslemisareti;
bool islemSirasi=false;
bool islemOnceligi=true;
bool mevcutToplama=false;
bool mevcutCikarma=false;
bool mevcutCarpma=false;
bool mevcutBolme=false;
bool mevcutEsittir=false;
bool mevcutUs=false;
bool mevcutFakt=false;
bool mevcutSin=false;
bool mevcutCos=false;
bool mevcutTan=false;
bool mevcutCot=false;
bool mevcutArcsin=false;
bool mevcutArccos=false;
bool mevcutArctan=false;
bool mevcutArccot=false;
bool mevcutLog=false;
bool mevcutYuzde=false;
bool mevcutMod=false;
bool mevcutKok=false;
bool islemVar=false;
bool sifirVar=false;
bool virgulVar=false;
bool ikiliIslem=false;
bool ilkSayi=true;
bool satirIlkSayi=true;
bool esittirVar=false;
bool hataVar=false;
bool kokVar=false;
bool sinVar=false;
bool cosVar=false;
bool tanVar=false;
bool cotVar=false;
bool arcsinVar=false;
bool arccosVar=false;
bool arctanVar=false;
bool arccotVar=false;
bool logVar=false;
bool faktVar=false;
bool yuzdeVar=false;
bool modVar=false;
double sonuc=0;
double sonucK=0;
double geciciSonuc=0;
double sayi2=0;
double sayi1=0;
double oncekiDouble=0;
double tri=0;
const double pi=3.14159265;
const double e=2.71828182;
int islemSayac=0;
int DiziSayac=0;
int yer=0;
int satirSayac=1;

ehm::ehm(QWidget *parent) : QMainWindow(parent),ui(new Ui::ehm)
{
    QTextCodec::setCodecForCStrings(QTextCodec::codecForName("utf8") );
    QTextCodec::setCodecForTr(QTextCodec::codecForName("utf8") );
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("utf8") );
    ui->setupUi(this);
    fonkBasit();
    fonkIslemTuru();
    layout()->setSizeConstraint(QLayout::SetFixedSize);
    connect(ui->btnGizle,SIGNAL(clicked()),this,SLOT(fonkGelismis()));
    connect(ui->btnGecmis,SIGNAL(clicked()),this,SLOT(fonkGecmis()));
    connect(ui->btn1,SIGNAL(clicked()),this,SLOT(fonkbtn1()));
    connect(ui->btn2,SIGNAL(clicked()),this,SLOT(fonkbtn2()));
    connect(ui->btn3,SIGNAL(clicked()),this,SLOT(fonkbtn3()));
    connect(ui->btn4,SIGNAL(clicked()),this,SLOT(fonkbtn4()));
    connect(ui->btn5,SIGNAL(clicked()),this,SLOT(fonkbtn5()));
    connect(ui->btn6,SIGNAL(clicked()),this,SLOT(fonkbtn6()));
    connect(ui->btn7,SIGNAL(clicked()),this,SLOT(fonkbtn7()));
    connect(ui->btn8,SIGNAL(clicked()),this,SLOT(fonkbtn8()));
    connect(ui->btn9,SIGNAL(clicked()),this,SLOT(fonkbtn9()));
    connect(ui->btn0,SIGNAL(clicked()),this,SLOT(fonkbtn0()));
    connect(ui->btnVirgul,SIGNAL(clicked()),this,SLOT(fonkVirgul()));
    connect(ui->btnTemizle,SIGNAL(clicked()),this,SLOT(fonkTemizle()));
    connect(ui->btnToplama,SIGNAL(clicked()),this,SLOT(fonkToplama()));
    connect(ui->btnCikarma,SIGNAL(clicked()),this,SLOT(fonkCikarma()));
    connect(ui->btnCarpma,SIGNAL(clicked()),this,SLOT(fonkCarpma()));
    connect(ui->btnBolme,SIGNAL(clicked()),this,SLOT(fonkBolme()));
    connect(ui->btnEsittir,SIGNAL(clicked()),this,SLOT(fonkEsittir()));
    connect(ui->btnGeriAl,SIGNAL(clicked()),this,SLOT(fonkGeriAl()));
    connect(ui->btnIsaret,SIGNAL(clicked()),this,SLOT(fonkIsaret()));
    connect(ui->btnKarekok,SIGNAL(clicked()),this,SLOT(fonkKarekok()));
    connect(ui->btnYuzde,SIGNAL(clicked()),this,SLOT(fonkYuzde()));
    connect(ui->btnUs,SIGNAL(clicked()),this,SLOT(fonkUs()));
    connect(ui->btn1bolu,SIGNAL(clicked()),this,SLOT(fonk1bolu()));
    connect(ui->btnFakt,SIGNAL(clicked()),this,SLOT(fonkFakt()));
    connect(ui->btnSin,SIGNAL(clicked()),this,SLOT(fonkSin()));
    connect(ui->btnCos,SIGNAL(clicked()),this,SLOT(fonkCos()));
    connect(ui->btnTan,SIGNAL(clicked()),this,SLOT(fonkTan()));
    connect(ui->btnCot,SIGNAL(clicked()),this,SLOT(fonkCot()));
    connect(ui->btnPi,SIGNAL(clicked()),this,SLOT(fonkPi()));
    connect(ui->btnE,SIGNAL(clicked()),this,SLOT(fonkE()));
    connect(ui->btnArcsin,SIGNAL(clicked()),this,SLOT(fonkArcsin()));
    connect(ui->btnArccos,SIGNAL(clicked()),this,SLOT(fonkArccos()));
    connect(ui->btnArctan,SIGNAL(clicked()),this,SLOT(fonkArctan()));
    connect(ui->btnArccot,SIGNAL(clicked()),this,SLOT(fonkArccot()));
    connect(ui->btnLog,SIGNAL(clicked()),this,SLOT(fonkLog()));
    connect(ui->btnMod,SIGNAL(clicked()),this,SLOT(fonkMod()));
    connect(ui->btnGecmisSil,SIGNAL(clicked()),this,SLOT(fonkGecmisSil()));
    connect(ui->btnGecmisKaydet,SIGNAL(clicked()),this,SLOT(fonkGecmisKaydet()));
    connect(ui->actionQtHakkinda,SIGNAL(triggered()),this,SLOT(fonkQtHakkinda()));
    connect(ui->actionEhmHakkinda,SIGNAL(triggered()),this,SLOT(fonkHakkinda()));
    connect(ui->actionGelismis,SIGNAL(triggered()),this,SLOT(fonkGelismis()));
    connect(ui->actionGecmis,SIGNAL(triggered()),this,SLOT(fonkGecmis()));
    connect(ui->actionBasit2,SIGNAL(triggered()),this,SLOT(fonkBasit()));
    connect(ui->actionIslemOnceligi,SIGNAL(triggered()),this,SLOT(fonkDegistirIO()));
    connect(ui->actionIslemSirasi,SIGNAL(triggered()),this,SLOT(fonkDegistirIS()));
}

void ehm::fonkIslemTuru()
{
    if(islemOnceligi==true)
    {
        ui->statusBar->showMessage(surum+" : "+tr("İşlem Önceliği Etkin"));
        ui->btnIsaret->setEnabled(false);
        ui->btn1bolu->setEnabled(false);
    }
    else if(islemSirasi==true)
    {
        ui->statusBar->showMessage(surum+" : "+tr("İşlem Sırası Etkin"));
    }
}

void ehm::fonkDegistirIO()
{
        islemSirasi=false;
        islemOnceligi=true;
        ui->ekran->setText("");
        fonkSifirla();
        islem="";
        ui->statusBar->showMessage(surum+" : "+tr("İşlem Önceliği Etkin"));
        ui->actionIslemOnceligi->setChecked(true);
        ui->actionIslemSirasi->setChecked(false);
}

void ehm::fonkDegistirIS()
{
        islemSirasi=true;
        islemOnceligi=false;
        ui->ekran->setText("");
        fonkSifirla();
        islem="";
        ui->statusBar->showMessage(surum+" : "+tr("İşlem Sırası Etkin"));
        ui->actionIslemSirasi->setChecked(true);
        ui->actionIslemOnceligi->setChecked(false);
}

void ehm::fonkHakkinda()
{
    if(formHakkinda.isHidden()==true)
    {
        formHakkinda.show();
    }
    else
    {
        formHakkinda.hide();
    }
}

void ehm::fonkQtHakkinda()
{
    QMessageBox::aboutQt(this,tr("Qt hakkında"));
}

void ehm::fonkGelismis()
{
    if(ui->gbMat->isHidden()==true)
    {
        ui->gbMat->show();
        ui->btnGizle->setText(QChar(0x2191));
        ui->actionGelismis->setChecked(true);
    }
    else
    {
        ui->gbMat->hide();
        ui->btnGizle->setText(QChar(0x2193));
        ui->actionGelismis->setChecked(false);
    }
}

void ehm::fonkGecmis()
{
    if(ui->gbGecmis->isHidden()==true)
    {
        ui->gbGecmis->show();
        ui->actionGecmis->setChecked(true);       
    }
    else
    {
        ui->gbGecmis->hide();
        ui->actionGecmis->setChecked(false);
    }
}

void ehm::fonkBasit()
{
    ui->gbMat->hide();
    ui->gbGecmis->hide();
    ui->actionBasit2->setChecked(true);
    ui->actionGecmis->setChecked(false);
    ui->actionGelismis->setChecked(false);
}

void ehm::fonkGecmisSil()
{
    ui->textGecmis->clear();
    satirSayac=1;
    ui->statusBar->showMessage(surum+" : "+tr("Geçmiş Silindi"),10000);
}

void ehm::fonkGecmisKaydet()
{
    QString dosya = QFileDialog::getSaveFileName(this,tr("Kaydet"),"/home/untitled.txt",tr("Metin Dosyaları(*.txt);;Tüm Dosyalar(*.*)"));
    QFile f(dosya);
    if(f.open(QIODevice::WriteOnly))
    {
        QTextStream out(&f);
        out<<ui->textGecmis->toPlainText();
        out.flush();
    }
    ui->statusBar->showMessage(surum+" : "+tr("Geçmiş Kaydedildi"),10000);
}

void ehm::fonkSifirla()
{
    mevcutToplama=false;
    mevcutCikarma=false;
    mevcutCarpma=false;
    mevcutBolme=false;
    mevcutEsittir=false;
    mevcutUs=false;
    mevcutFakt=false;
    mevcutSin=false;
    mevcutCos=false;
    mevcutTan=false;
}

void ehm::fonkbtn(QString btn)
{
    if(islemSirasi==true)
    {
        fonkSifirla();
        if(islemVar==true)
        {
            ui->ekran->setText("");
            islemVar=false;
        }
        if(sifirVar==true)
        {
            ui->ekran->setText(btn);
        }
        else
        {
            onceki= ui->ekran->text();
            onceki.append(btn);
            ui->ekran->setText(onceki);
        }
        sifirVar=false;
        ikiliIslem=false;
    }
    else if(islemOnceligi==true)
    {
        if(mevcutEsittir==true)
        {
            ui->ekran->setText("");
            fonkSifirla();
        }
        onceki= ui->ekran->text();
        onceki.append(btn);
        ui->ekran->setText(onceki);
    }
}

void ehm::fonkbtn1()
{
    fonkbtn("1");
}

void ehm::fonkbtn2()
{
     fonkbtn("2");
}

void ehm::fonkbtn3()
{
     fonkbtn("3");
}

void ehm::fonkbtn4()
{
    fonkbtn("4");
}

void ehm::fonkbtn5()
{
     fonkbtn("5");
}

void ehm::fonkbtn6()
{
     fonkbtn("6");
}

void ehm::fonkbtn7()
{
     fonkbtn("7");
}

void ehm::fonkbtn8()
{
     fonkbtn("8");
}

void ehm::fonkbtn9()
{
     fonkbtn("9");
}

void ehm::fonkbtn0()
{
    fonkSifirla();
    if(islemSirasi==true)
    {
        if(islemVar==true)
        {
            ui->ekran->setText("");
            islemVar=false;
        }
        if(ui->ekran->text()=="")
        {
            ui->ekran->setText("0");
            sifirVar=true;
        }
        else if(sifirVar==false)
        {
            onceki=ui->ekran->text();
            onceki.append("0");
            ui->ekran->setText(onceki);
        }
        ikiliIslem=false;
    }
    else if(islemOnceligi==true)
    {
        fonkbtn("0");
    }
}

void ehm::fonkVirgul()
{
    if(islemSirasi==true)
    {
        if(virgulVar==false && sonucKS=="0")
        {
            islemVar=false;
            if(ui->ekran->text()=="")
            {
                ui->ekran->setText("0.");
                virgulVar=true;
            }
            else
            {
                onceki=ui->ekran->text();
                onceki.append(".");
                ui->ekran->setText(onceki);
                virgulVar=true;
            }
        }
        sifirVar=false;
    }

    else if(islemOnceligi==true)
    {
        if(ui->ekran->text()=="")
        {
            ui->ekran->setText("0.");
            virgulVar=true;
        }
        if(virgulVar==false)
        {
            onceki= ui->ekran->text();
            onceki.append(".");
            ui->ekran->setText(onceki);
            virgulVar=true;
        }
    }

}

void ehm::fonkVirgulKontrol()
{
    sonucK=sonuc;
    sonucK=sonucK*10;
    sonucKS=QString::number(sonucK);
    int size=sonucKS.size();
    sonucKS.remove(0,size-1);
}

void ehm::fonkTemizle()
{
    ui->ekran->setText("");
    ui->textGecmis->insertPlainText("\n");
    satirSayac=satirSayac-1;
    fonkSifirla();
    satirIlkSayi=true;
    sifirVar=false;
    virgulVar=false;
    islemVar=false;
    ilkSayi=true;
    geciciSayi1="0";
    geciciSayi2="0";
    geciciSonuc=0;
    kokVar=false;
    esittirVar=false;
    hataVar=false;
    ikiliIslem=false;
    sayi2=0;
    sayi1=0;
    sonuc=0;
    sonucK=0;
    sonucKS="0";
    oncekiDouble=0;
    tri=0;
    geciciSonuc=0;
}

void ehm::fonkIslemPro(QString islemAdi,QString islemIsareti,bool mevcutIslem)
{
    if(islemSirasi==true)
    {
        if(mevcutIslem==false)
        {
            fonkEsittir();
            if(satirIlkSayi==true)
            {
                ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> "+ui->ekran->text());
                satirIlkSayi=false;
                satirSayac=satirSayac+1;
            }
            else
            {
                ui->textGecmis->insertPlainText(ui->ekran->text());
            }
            if(islem!=islemAdi)
            {
                ilkSayi=true;
            }
            if(islemAdi=="mod")
            {
                ui->textGecmis->insertPlainText(" mod ");
            }
            else
            {
                ui->textGecmis->insertPlainText(" "+islemIsareti+" ");
            }
            islem=islemAdi;
            islemVar=true;
            fonkIslem();
            mevcutIslem=true;
            mevcutEsittir=true;
            ikiliIslem=true;
            sonucKS="0";
        }
    }
    else if(islemOnceligi==true)
    {
        onceki= ui->ekran->text();

        if(islemIsareti=="]")
        {
            onceki.append("sin");
        }
        else if(islemIsareti=="[")
        {
            onceki.append("cos");
        }
        else if(islemIsareti=="}")
        {
            onceki.append("tan");
        }
        else if(islemIsareti=="{")
        {
            onceki.append("cot");
        }
        else if(islemIsareti=="?")
        {
            onceki.append("arcsin");
        }
        else if(islemIsareti=="&")
        {
            onceki.append("arccos");
        }
        else if(islemIsareti=="<")
        {
            onceki.append("arctan");
        }
        else if(islemIsareti==">")
        {
            onceki.append("arccot");
        }
        else if(islemIsareti=="|")
        {
            if(ui->rbtnTe)
            {
                onceki.append("ln");
            }
            else
            {
                onceki.append("log");
            }
        }
        else if(islemIsareti=="*")
        {
            onceki.append("mod");
        }
        else
        {
            onceki.append(islemIsareti);
        }
        DiziIslemisareti.append(islemIsareti);
        ui->ekran->setText(onceki);
        islemSayac=islemSayac+1;
        fonkSifirla();
    }
}

void ehm::fonkToplama()
{
    fonkIslemPro("toplama","+",mevcutToplama);
}

void ehm::fonkCikarma()
{
    fonkIslemPro("cikarma","-",mevcutCikarma);
}

void ehm::fonkCarpma()
{
    fonkIslemPro("carpma","x",mevcutCarpma);
}

void ehm::fonkBolme()
{
    fonkIslemPro("bolme","/",mevcutBolme);
}

void ehm::fonkUs()
{
    fonkIslemPro("us","^",mevcutUs);
}

void ehm::fonkIslem()
{
    if(islemSirasi==true)
    {
        if(ilkSayi==true)
        {
            sayi1=ui->ekran->text().toDouble();
            ilkSayi=false;
        }
        else
        {
            sayi2=ui->ekran->text().toDouble();
            if(islem=="toplama")
            {
                sonuc=sayi1+sayi2;
            }
            else if(islem=="cikarma")
            {
                sonuc=sayi1-sayi2;
            }
            else if(islem=="carpma")
            {
                sonuc=sayi1*sayi2;
            }
            else if(islem=="bolme")
            {
                sonuc=sayi1/sayi2;
            }
            else if(islem=="mod")
            {
                int modSonuc=sayi1/sayi2;
                modSonuc=sayi1-(modSonuc*sayi2);
                sonuc=modSonuc;
            }
            else if(islem=="us")
            {
                    double usSonuc=1;
                    int usSayac=sayi2;
                    for(;usSayac>0;usSayac=usSayac-1)
                    {
                        usSonuc=usSonuc*sayi1;
                    }
                    sonuc=usSonuc;
                    fonkVirgulKontrol();
                    ui->ekran->setText(QString::number(sonuc));
                    sayi1=sonuc;
                    ui->textGecmis->insertPlainText(QString::number(sayi2)+" = "+QString::number(sonuc)+"\n");
                    satirIlkSayi=true;

            }
            if(islem!="us")
            {
                fonkVirgulKontrol();
                ui->ekran->setText(QString::number(sonuc));
                sayi1=sonuc;
                ui->textGecmis->insertPlainText(QString::number(sayi2)+" = "+QString::number(sonuc)+"\n");
                satirIlkSayi=true;
            }
        }
    }
    else if(islemOnceligi==true)
    {
        yedektext=ui->ekran->text();
        ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> "+yedektext);
        for(int trisayac=0;trisayac<yedektext.size();trisayac++)
        {
            yedektext.replace(QString("sin"),QString("]"));
            yedektext.replace(QString("cos"),QString("["));
            yedektext.replace(QString("tan"),QString("}"));
            yedektext.replace(QString("cot"),QString("{"));
            yedektext.replace(QString("arcsin"),QString("?"));
            yedektext.replace(QString("arccos"),QString("&"));
            yedektext.replace(QString("arctan"),QString("<"));
            yedektext.replace(QString("arccot"),QString(">"));
            yedektext.replace(QString("log"),QString("|"));
            yedektext.replace(QString("ln"),QString("|"));
            yedektext.replace(QString("mod"),QString("*"));
        }
        yedektextBas=yedektext;
        yedektextSon=yedektext;
        int Sayac=0;
        while(Sayac<islemSayac)
        {
            int size=yedektext.size();
            yer=yedektext.indexOf(DiziIslemisareti.value(Sayac));
            diziyeIsaret=yedektext.at(yer);
            yedektextBas.remove(yer,size-1);
            yedektextSon.remove(0,yer+1);
            Dizi.append(yedektextBas);
            Dizi.append(diziyeIsaret);
            yedektext=yedektextSon;
            yedektextBas=yedektextSon;
            Sayac=Sayac+1;
        }
        int yerEsittir=yedektextSon.indexOf("=");
        yedektextSon.remove(yerEsittir,yerEsittir);
        Dizi.append(yedektextSon);
        Dizi.append("=");
        if(sinVar==true)
        {
            fonkTrigIslem(sinVar,"sin","]");
        }
        if(cosVar==true)
        {
            fonkTrigIslem(cosVar,"cos","[");
        }
        if(tanVar==true)
        {
            fonkTrigIslem(tanVar,"tan","}");
        }
        if(cotVar==true)
        {
            fonkTrigIslem(cotVar,"cot","{");
        }
        if(arcsinVar==true)
        {
            fonkTrigIslem(arcsinVar,"asin","?");
        }
        if(arccosVar==true)
        {
            fonkTrigIslem(arccosVar,"acos","&");
        }
        if(arccosVar==true)
        {
            fonkTrigIslem(arctanVar,"atan","<");
        }
        if(arccosVar==true)
        {
            fonkTrigIslem(arccotVar,"acot",">");
        }
        if(modVar==true)
        {
            int modYer=Dizi.indexOf("*");
            QString chMod=Dizi.value(modYer-1);
            if(chMod=="=")
            {
                QMessageBox::critical(this,"hata!","Hatali islem","tamam");
            }
            else
            {
                QString modSayi=Dizi.value(modYer+1);
                double modSayiDouble=modSayi.toDouble();
                double chModDouble=chMod.toDouble();
                int modSonuc=chModDouble/modSayiDouble;
                modSonuc=chModDouble-(modSonuc*modSayiDouble);
                geciciSonuc=modSonuc;
            }
            Dizi.replace(modYer,QString::number(geciciSonuc));
            Dizi.removeAt(modYer-1);
            Dizi.removeAt(modYer);
        }
        if(yuzdeVar==true)
        {
            int yuzdeYer=Dizi.indexOf("%");
            QString chYuzde=Dizi.value(yuzdeYer-1);
            if(chYuzde=="=")
            {
                QMessageBox::critical(this,"hata!","Hatali islem","tamam");
            }
            else
            {
                geciciSonuc=chYuzde.toDouble()/100;
                Dizi.replace(yuzdeYer,QString::number(geciciSonuc));
                Dizi.removeAt(yuzdeYer-1);
                Dizi.removeAt(yuzdeYer);
            }
        }
        if(logVar==true)
        {
            int logYer=Dizi.indexOf("|");
            QString chlog=Dizi.value(logYer-1);
            if(chlog=="=")
            {
                QString logsayi=Dizi.value(logYer+1);
                double logsayidouble=logsayi.toDouble();
                if(ui->rbtnT2->isChecked()==true)
                {
                    geciciSonuc=log2(logsayidouble);
                }
                else if(ui->rbtnT10->isChecked()==true)
                {
                    geciciSonuc=log10(logsayidouble);
                }
                else if(ui->rbtnTe->isChecked()==true)
                {
                    geciciSonuc=log(logsayidouble);
                }
                Dizi.replace(logYer,QString::number(geciciSonuc));
                Dizi.removeAt(logYer-1);
                Dizi.removeAt(logYer);
            }
            else
            {
                QString logsayi=Dizi.value(logYer+1);
                double logsayidouble=logsayi.toDouble();
                if(ui->rbtnT2->isChecked()==true)
                {
                    geciciSonuc=log2(logsayidouble);
                    geciciSonuc=geciciSonuc*chlog.toDouble();
                }
                else if(ui->rbtnT10->isChecked()==true)
                {
                    geciciSonuc=log10(logsayidouble);
                    geciciSonuc=geciciSonuc*chlog.toDouble();
                }
                else if(ui->rbtnTe->isChecked()==true)
                {
                    geciciSonuc=log(logsayidouble);
                    geciciSonuc=geciciSonuc*chlog.toDouble();
                }
                Dizi.replace(logYer,QString::number(geciciSonuc));
                Dizi.removeAt(logYer-1);
                Dizi.removeAt(logYer);
            }
        }
        if(faktVar==true)
        {
            while(Dizi.contains("!")==true)
            {
                int yerFakt=Dizi.indexOf("!");
                Dizi.removeAt(yerFakt+1);
                geciciSayi1=Dizi.value(yerFakt-1);
                int fakt=1;
                double faktSayac=geciciSayi1.toDouble();
                while(faktSayac>0)
                {
                    fakt=fakt*faktSayac;
                    faktSayac=faktSayac-1;
                }
                geciciSonuc=fakt;
                Dizi.replace(yerFakt-1,QString::number(geciciSonuc));
                Dizi.removeAt(yerFakt);
            }
            faktVar=false;
        }
        if(kokVar==true)
        {
            for(int koksayac=0;koksayac<Dizi.size();koksayac++)
            {
                QString kokkontrol=Dizi.value(koksayac);
                if(kokkontrol.contains(QChar(0x221A))==true)
                {
                    int yerkok=kokkontrol.indexOf(QChar(0x221A));
                    QString DiziKokBas=Dizi.value(koksayac);
                    QString DiziKokSon=Dizi.value(koksayac);
                    if(DiziKokBas.indexOf(QChar(0x221A))==true)
                    {
                        int kokkontrolsize=kokkontrol.size();
                        DiziKokBas.remove(yerkok,kokkontrolsize-1);
                        DiziKokSon.remove(0,yerkok+1);
                        geciciSonuc=sqrt(DiziKokSon.toDouble());
                        geciciSonuc=geciciSonuc*DiziKokBas.toDouble();
                    }
                    else
                    {
                        DiziKokSon.remove(0,yerkok+1);
                        geciciSonuc=sqrt(DiziKokSon.toDouble());
                    }
                    Dizi.replace(koksayac,QString::number(geciciSonuc));
                }
            }
            kokVar=false;
        }
        while(Dizi.lastIndexOf("^")!=-1)
        {
            int usYer=Dizi.lastIndexOf("^");
            geciciSayi1=Dizi.value(usYer-1);
            geciciSayi2=Dizi.value(usYer+1);
            double usSonuc=1;
            int usSayac=geciciSayi2.toDouble();
            for(;usSayac>0;usSayac=usSayac-1)
            {
                usSonuc=usSonuc*geciciSayi1.toDouble();
            }
            geciciSonuc=usSonuc;
            Dizi.replace(usYer,QString::number(geciciSonuc));
            Dizi.removeAt(usYer-1);
            Dizi.removeAt(usYer);
        }
        DiziSayac=0;
        while(Dizi.value(DiziSayac)!="=")
        {
            if(Dizi.value(DiziSayac)=="x"||Dizi.value(DiziSayac)=="/")
            {
                if(Dizi.value(DiziSayac)=="x")
                {
                    geciciSayi1=Dizi.value(DiziSayac-1);
                    geciciSayi2=Dizi.value(DiziSayac+1);
                    geciciSonuc=geciciSayi1.toDouble()*geciciSayi2.toDouble();
                    Dizi.replace(DiziSayac,QString::number(geciciSonuc));
                    Dizi.removeAt(DiziSayac-1);
                    Dizi.removeAt(DiziSayac);
                    DiziSayac=DiziSayac-1;
                }
                else if(Dizi.value(DiziSayac)=="/")
                {
                    geciciSayi1=Dizi.value(DiziSayac-1);
                    geciciSayi2=Dizi.value(DiziSayac+1);
                    geciciSonuc=geciciSayi1.toDouble()/geciciSayi2.toDouble();
                    Dizi.replace(DiziSayac,QString::number(geciciSonuc));
                    Dizi.removeAt(DiziSayac-1);
                    Dizi.removeAt(DiziSayac);
                    DiziSayac=DiziSayac-1;
                }
            }
            DiziSayac=DiziSayac+1;
        }
        DiziSayac=0;
        while(Dizi.value(DiziSayac)!="=")
        {
            if(Dizi.value(DiziSayac)=="+"||Dizi.value(DiziSayac)=="-")
            {
                if(Dizi.value(DiziSayac)=="+")
                {
                    geciciSayi1=Dizi.value(DiziSayac-1);

                    geciciSayi2=Dizi.value(DiziSayac+1);
                    geciciSonuc=geciciSayi1.toDouble()+geciciSayi2.toDouble();
                    Dizi.replace(DiziSayac,QString::number(geciciSonuc));
                    Dizi.removeAt(DiziSayac-1);
                    Dizi.removeAt(DiziSayac);
                    DiziSayac=DiziSayac-1;
                }
                else if(Dizi.value(DiziSayac)=="-")
                {
                    geciciSayi1=Dizi.value(DiziSayac-1);
                    geciciSayi2=Dizi.value(DiziSayac+1);
                    geciciSonuc=geciciSayi1.toDouble()-geciciSayi2.toDouble();
                    Dizi.replace(DiziSayac,QString::number(geciciSonuc));
                    Dizi.removeAt(DiziSayac-1);
                    Dizi.removeAt(DiziSayac);
                    DiziSayac=DiziSayac-1;
                }
            }
            DiziSayac=DiziSayac+1;
        }
        sonuc=geciciSonuc;
        ui->ekran->setText(QString::number(sonuc));
        ui->textGecmis->insertPlainText(" "+QString::number(sonuc)+"\n");
        satirSayac=satirSayac+1;
        Dizi.clear();
        islemSayac=0;
        DiziIslemisareti.clear();
    }
}

void ehm::fonkTrigIslem(bool trigVar,QString islem,QString islemIsareti)
{
    if(trigVar==true)
    {
        do
        {
            int trigYer=Dizi.indexOf(islemIsareti);
            QString chtrig=Dizi.value(trigYer-1);
            if(chtrig=="=")
            {
                QString trigsayi=Dizi.value(trigYer+1);
                double trigsayidouble=trigsayi.toDouble();
                if(ui->rbtnDerece->isChecked()==true)
                {
                   trigsayidouble=(trigsayidouble*pi)/180;
                }
                if(ui->rbtnRadyan->isChecked()==true){}
                if(ui->rbtnGrad->isChecked()==true)
                {
                    trigsayidouble=(trigsayidouble*pi)/200;
                }
                if(islem=="sin")
                {
                    geciciSonuc=sin(trigsayidouble);
                }
                if(islem=="cos")
                {
                    geciciSonuc=cos(trigsayidouble);
                }
                if(islem=="tan")
                {
                    geciciSonuc=tan(trigsayidouble);
                }
                if(islem=="cot")
                {
                    geciciSonuc=tan(trigsayidouble);
                    geciciSonuc=1/geciciSonuc;
                }
                if(islem=="asin")
                {
                    geciciSonuc=asin(trigsayidouble);
                }
                if(islem=="acos")
                {
                    geciciSonuc=acos(trigsayidouble);
                }
                if(islem=="atan")
                {
                    geciciSonuc=atan(trigsayidouble);
                }
                if(islem=="acot")
                {
                    geciciSonuc=atan(trigsayidouble);
                    geciciSonuc=1/geciciSonuc;
                }
                Dizi.replace(trigYer,QString::number(geciciSonuc));
                Dizi.removeAt(trigYer-1);
                Dizi.removeAt(trigYer);
            }
            else
            {
                QString trigsayi=Dizi.value(trigYer+1);
                QString trigcarpan=Dizi.value(trigYer-1);
                double trigsayidouble=trigsayi.toDouble();
                if(ui->rbtnDerece->isChecked()==true)
                {
                   trigsayidouble=(trigsayidouble*pi)/180;
                }
                if(ui->rbtnRadyan->isChecked()==true){}
                if(ui->rbtnGrad->isChecked()==true)
                {
                    trigsayidouble=(trigsayidouble*pi)/200;
                }

                if(islem=="sin")
                {
                    geciciSonuc=sin(trigsayidouble);
                    geciciSonuc=geciciSonuc*trigcarpan.toDouble();
                }
                if(islem=="cos")
                {
                    geciciSonuc=cos(trigsayidouble);
                    geciciSonuc=geciciSonuc*trigcarpan.toDouble();
                }
                if(islem=="tan")
                {
                    geciciSonuc=tan(trigsayidouble);
                    geciciSonuc=geciciSonuc*trigcarpan.toDouble();
                }
                if(islem=="cot")
                {
                    geciciSonuc=tan(trigsayidouble);
                    geciciSonuc=geciciSonuc*trigcarpan.toDouble();
                    geciciSonuc=1/geciciSonuc;
                }
                if(islem=="asin")
                {
                    geciciSonuc=asin(trigsayidouble);
                    geciciSonuc=geciciSonuc*trigcarpan.toDouble();
                }
                if(islem=="acos")
                {
                    geciciSonuc=acos(trigsayidouble);
                    geciciSonuc=geciciSonuc*trigcarpan.toDouble();
                }
                if(islem=="atan")
                {
                    geciciSonuc=atan(trigsayidouble);
                    geciciSonuc=geciciSonuc*trigcarpan.toDouble();
                }
                if(islem=="acot")
                {
                    geciciSonuc=atan(trigsayidouble);
                    geciciSonuc=geciciSonuc*trigcarpan.toDouble();
                    geciciSonuc=1/geciciSonuc;
                }
                Dizi.replace(trigYer,QString::number(geciciSonuc));
                Dizi.removeAt(trigYer-1);
                Dizi.removeAt(trigYer);
            }
        }while(Dizi.contains(islemIsareti));
        trigVar=false;
    }
}

void ehm::fonkEsittir()
{
    if(islemSirasi==true)
    {
        if(mevcutEsittir==false)
        {
            fonkIslem();
            ikiliIslem=false;
            islemVar=true;
            virgulVar=false;
            ilkSayi=true;
            islem="";
        }
    }
    else if(islemOnceligi==true)
    {
        mevcutEsittir=true;
        onceki= ui->ekran->text();
        onceki.append("=");
        ui->ekran->setText(onceki);
        fonkIslem();
    }
}

void ehm::fonkGeriAl()
{
    if(islemSirasi==true)
    {
        if(islemVar==true)
        {
            islemVar=false;
            islem="";
        }
        else
        {
            silinecek=ui->ekran->text();
            QString silinecekK=silinecek;
            int silinecekKS=silinecekK.size();
            silinecekK.remove(0,silinecekKS-1);
            if(silinecekK==".")
            {
                virgulVar=false;
            }
            silinecek.chop(1);
            ui->ekran->setText(silinecek);
        }
    }
    else if(islemOnceligi==true)
    {
        silinecek=ui->ekran->text();
        silinecek.chop(1);
        ui->ekran->setText(silinecek);
    }
}

void ehm::fonkIsaret()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            oncekiDouble=ui->ekran->text().toDouble();
            if(oncekiDouble>0)
            {
                onceki=ui->ekran->text();
                onceki="-"+ onceki;
                ui->ekran->setText(onceki);
            }
            else if(oncekiDouble<0)
            {
                onceki=ui->ekran->text();
                onceki.remove(0,1);
                ui->ekran->setText(onceki);
            }
        }
    }
}

void ehm::fonkKarekok()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            oncekiDouble=ui->ekran->text().toDouble();
            ui->ekran->setText(QString::number(sqrt(oncekiDouble)));
            ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> "+QChar(0x221A)+QString::number(oncekiDouble)+" = "+QString::number(sqrt(oncekiDouble))+"\n");
            satirSayac=satirSayac+1;
            islemVar=true;
        }
    }
    else if(islemOnceligi==true)
    {
        onceki= ui->ekran->text();
        onceki.append(QChar(0x221A));
        ui->ekran->setText(onceki);
        kokVar=true;
        fonkSifirla();
    }
}

void ehm::fonkYuzde()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            oncekiDouble=ui->ekran->text().toDouble();
            ui->ekran->setText(QString::number(oncekiDouble/100));
            ui->textGecmis->insertPlainText("% "+QString::number(oncekiDouble)+" = "+QString::number(oncekiDouble/100)+"\n");
            islemVar=true;
        }
    }
    if(islemOnceligi==true)
    {
        yuzdeVar=true;
        fonkIslemPro("yuzde","%",mevcutYuzde);
    }
}

void ehm::fonk1bolu()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            oncekiDouble=ui->ekran->text().toDouble();
            ui->ekran->setText(QString::number(1/oncekiDouble));
            ui->textGecmis->insertPlainText(QString::number(satirSayac)+"-> 1 / "+QString::number(oncekiDouble)+" = "+QString::number(1/oncekiDouble)+"\n");
            satirSayac=satirSayac+1;
            islemVar=true;
        }
    }
}

void ehm::fonkFakt()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            int fakt=1;
            fonkEsittir();
            //ui->lblIslem->setText("!");
            oncekiDouble=ui->ekran->text().toDouble();
            double faktSayac=oncekiDouble;
            while(faktSayac>0)
            {
                fakt=fakt*faktSayac;
                faktSayac=faktSayac-1;
            }
            ui->ekran->setText(QString::number(fakt));
            ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> "+QString::number(oncekiDouble)+" ! ="+QString::number(fakt)+"\n");
            satirSayac=satirSayac+1;
        }
    }
    else if(islemOnceligi==true)
    {
        fonkIslemPro("fakt","!",mevcutFakt);
        faktVar=true;
    }
}

void ehm::fonkSin()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            oncekiDouble=ui->ekran->text().toDouble();
            tri=oncekiDouble;
            if(ui->rbtnDerece->isChecked()==true)
            {
                oncekiDouble=(oncekiDouble*pi)/180;
            }
            else if(ui->rbtnRadyan->isChecked()==true){}
            else if(ui->rbtnGrad->isChecked()==true)
            {
                oncekiDouble=(oncekiDouble*pi)/200;
            }
            sonuc=sin(oncekiDouble);
            ui->ekran->setText(QString::number(sonuc));
            ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> sin ("+QString::number(tri)+") = "+QString::number(sonuc)+"\n");
            islemVar=true;
            satirSayac=satirSayac+1;
        }
    }
    if(islemOnceligi==true)
    {
        sinVar=true;
        fonkIslemPro("sin","]",mevcutSin);
    }
}

void ehm::fonkCos()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            oncekiDouble=ui->ekran->text().toDouble();
            tri=oncekiDouble;
            if(ui->rbtnDerece->isChecked()==true)
            {
                oncekiDouble=(oncekiDouble*pi)/180;
            }
            else if(ui->rbtnRadyan->isChecked()==true){}
            else if(ui->rbtnGrad->isChecked()==true)
            {
                oncekiDouble=(oncekiDouble*pi)/200;
            }
            sonuc=cos(oncekiDouble);
            ui->ekran->setText(QString::number(sonuc));
            ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> cos ("+QString::number(tri)+") = "+QString::number(sonuc)+"\n");
            islemVar=true;
        }
    }
    else if(islemOnceligi==true)
    {
        cosVar=true;
        fonkIslemPro("cos","[",mevcutCos);
    }
}

void ehm::fonkTan()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            oncekiDouble=ui->ekran->text().toDouble();
            tri=oncekiDouble;
            if(ui->rbtnDerece->isChecked()==true)
            {
                oncekiDouble=(oncekiDouble*pi)/180;
            }
            else if(ui->rbtnRadyan->isChecked()==true){}
            else if(ui->rbtnGrad->isChecked()==true)
            {
                oncekiDouble=(oncekiDouble*pi)/200;
            }
            sonuc=tan(oncekiDouble);
            ui->ekran->setText(QString::number(sonuc));
            ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> tan ("+QString::number(tri)+") = "+QString::number(sonuc)+"\n");
            islemVar=true;
        }
    }
    if(islemOnceligi==true)
    {
        tanVar=true;
        fonkIslemPro("tan","}",mevcutTan);
    }
}

void ehm::fonkCot()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            oncekiDouble=ui->ekran->text().toDouble();
            tri=oncekiDouble;
            if(ui->rbtnDerece->isChecked()==true)
            {
                oncekiDouble=(oncekiDouble*pi)/180;
            }
            else if(ui->rbtnRadyan->isChecked()==true){}
            else if(ui->rbtnGrad->isChecked()==true)
            {
                oncekiDouble=(oncekiDouble*pi)/200;
            }
            sonuc=tan(oncekiDouble);
            sonuc=1/sonuc;
            ui->ekran->setText(QString::number(sonuc));
            ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> cot ("+QString::number(tri)+") = "+QString::number(sonuc)+"\n");
            islemVar=true;
        }
    }
    if(islemOnceligi==true)
    {
        cotVar=true;
        fonkIslemPro("cot","{",mevcutCot);
    }
}

void ehm::fonkArcsin()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            islemVar=true;
            //ui->lblIslem->setText("Arcsin");
            oncekiDouble=ui->ekran->text().toDouble();
            tri=oncekiDouble;
            if(ui->rbtnDerece->isChecked()==true)
            {
                sonuc=asin(oncekiDouble)*180/pi;
            }
            else if(ui->rbtnRadyan->isChecked()==true)
            {
                sonuc=asin(oncekiDouble);
            }
            else if(ui->rbtnGrad->isChecked()==true)
            {
                sonuc=asin(oncekiDouble)*200/pi;
            }
            ui->ekran->setText(QString::number(sonuc));
            ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> arcsin ("+QString::number(tri)+") = "+QString::number(sonuc)+"\n");
        }
    }
    if(islemOnceligi==true)
    {
        arcsinVar=true;
        fonkIslemPro("asin","?",mevcutArcsin);
    }
}

void ehm::fonkArccos()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            islemVar=true;
            oncekiDouble=ui->ekran->text().toDouble();
            tri=oncekiDouble;
            if(ui->rbtnDerece->isChecked()==true)
            {
                sonuc=acos(oncekiDouble)*180/pi;
            }
            else if(ui->rbtnRadyan->isChecked()==true)
            {
                sonuc=acos(oncekiDouble);
            }
            else if(ui->rbtnGrad->isChecked()==true)
            {
                sonuc=acos(oncekiDouble)*200/pi;
            }
            ui->ekran->setText(QString::number(sonuc));
            ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> arccos ("+QString::number(tri)+") = "+QString::number(sonuc)+"\n");
        }
    }
    if(islemOnceligi==true)
    {
        arccosVar=true;
        fonkIslemPro("acos","&",mevcutArccos);
    }
}

void ehm::fonkArctan()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            islemVar=true;
            oncekiDouble=ui->ekran->text().toDouble();
            tri=oncekiDouble;
            if(ui->rbtnDerece->isChecked()==true)
            {
                sonuc=atan(oncekiDouble)*180/pi;
            }
            else if(ui->rbtnRadyan->isChecked()==true)
            {
                sonuc=atan(oncekiDouble);
            }
            else if(ui->rbtnGrad->isChecked()==true)
            {
                sonuc=atan(oncekiDouble)*200/pi;
            }
            ui->ekran->setText(QString::number(sonuc));
            ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> arctan ("+QString::number(tri)+") = "+QString::number(sonuc)+"\n");
        }
    }
    if(islemOnceligi==true)
    {
        arctanVar=true;
        fonkIslemPro("atan","<",mevcutArctan);
    }
}

void ehm::fonkArccot()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            islemVar=true;
            oncekiDouble=ui->ekran->text().toDouble();
            tri=oncekiDouble;
            if(ui->rbtnDerece->isChecked()==true)
            {
                sonuc=atan(oncekiDouble)*180/pi;
            }
            else if(ui->rbtnRadyan->isChecked()==true)
            {
                sonuc=atan(oncekiDouble);
            }
            else if(ui->rbtnGrad->isChecked()==true)
            {
                sonuc=atan(oncekiDouble)*200/pi;
            }
            sonuc=1/sonuc;
            ui->ekran->setText(QString::number(sonuc));
            ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> arccot ("+QString::number(tri)+") = "+QString::number(sonuc)+"\n");
        }
    }
    if(islemOnceligi==true)
    {
        arccotVar=true;
        fonkIslemPro("acot",">",mevcutArccot);
    }
}

void ehm::fonkPi()
{
    if(islemSirasi==true)
    {
        fonkSifirla();
        if(islemVar==true)
        {
            ui->ekran->setText("");
            islemVar=false;
        }
        ui->ekran->setText(QString::number(pi));
    }
    if(islemOnceligi==true)
    {
        fonkbtn(QString::number(pi));
    }
}

void ehm::fonkE()
{
    if(islemSirasi==true)
    {
        fonkSifirla();
        if(islemVar==true)
        {
            ui->ekran->setText("");
            islemVar=false;
        }
        ui->ekran->setText(QString::number(e));
    }
    if(islemOnceligi==true)
    {
        fonkbtn(QString::number(e));
    }
}

void ehm::fonkLog()
{
    if(islemSirasi==true)
    {
        if(ikiliIslem==true)
        {
            QMessageBox::critical(this,"hata!","Hatali islem","tamam");
        }
        else
        {
            islemVar=true;
            oncekiDouble=ui->ekran->text().toDouble();
            if(ui->rbtnT2->isChecked()==true)
            {
                sonuc=log2(oncekiDouble);
                ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> log2 ("+QString::number(oncekiDouble)+") = "+QString::number(sonuc)+"\n");
            }
            else if(ui->rbtnT10->isChecked()==true)
            {
                sonuc=log10(oncekiDouble);
                ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> log ("+QString::number(oncekiDouble)+") = "+QString::number(sonuc)+"\n");
            }
            else if(ui->rbtnTe->isChecked()==true)
            {
                sonuc=log(oncekiDouble);
                ui->textGecmis->insertPlainText(QString::number(satirSayac)+" -> ln ("+QString::number(oncekiDouble)+") = "+QString::number(sonuc)+"\n");
            }
            ui->ekran->setText(QString::number(sonuc));
        }
    }
    if(islemOnceligi==true)
    {
        logVar=true;
        fonkIslemPro("log","|",mevcutLog);
    }
}

void ehm::fonkMod()
{
    modVar=true;
    fonkIslemPro("mod","*",mevcutMod);
}

ehm::~ehm()
{
    delete ui;
}
